;;; EpikFail quiz mono salon, par Kitu :
;;;
;;; Description :
;;; Le script lit le fichier scripts\ef_mono\questions.txt de votre dossier d'installation de mIRC, à la recherche d'erreurs de syntaxe.
;;; Si aucune erreur n'est trouvée, le script copie le fichier questions.txt dans temp.txt, puis le jeu démarre.
;;; Le robot va alors prendre une question au hasard dans temp.txt et l'écrire sur le salon, puis supprimer cette question de ce même fichier.
;;; Quand temp.txt est vide, toutes les questions ont été posées, et le jeu est donc terminé, sauf si vous avez lancé le robot par la commande /start -u
;;; Par défaut le fichier questions.txt doit contenir sur chaque ligne : question \ réponse \ réponse synonyme \ ...
;;; Les réponses synonymes sont facultatives, vous pouvez donc écrire sur chaque ligne, simplement : question \ réponse
;;; Vous avez la possibilité de changer le séparateur "\" avec la commande /settoken suivi du nouveau caractère de séparation.
;;; Choisissez un caractère formellement absent des questions \ réponses.
;;;
;;; AIDE : ;;;
;;;
;;; Ces commandes sont à entrer dans l'editbox du mIRC qui fait tourner le quiz :
;;; Lancement : /start #salon ou uniquement /start sur le salon où se déroulera le jeu, ou encore /start -u pour que le jeu tourne en boucle.
;;; A chaque fois que /start est tapée, le quiz reprend du début, mais attention, les scores ne sont pas remis à zéro.
;;; Remise à zéro des scores : /rmscores (Note : si le quiz est lancé en boucle les scores sont remis à 0 à chaque redémarrage du jeu).
;;; Pause : /stop
;;; Redémarrage après pause : /restart
;;; Afficher les scores : /scores
;;; Pour définir le maestro du quiz tapez : /maestro <pseudo>
;;; Concernant le maestro du quiz, il s'agit du pseudo de la personne qui a droit aux show commands qui suivent.
;;; Définir un maestro n'est pas obligatoire, au lancement du bot le nick du maestro est automatiquement supprimé.
;;; Si aucun maestro n'est définit, ou même s'il est définit, les show commands qui suivent sont toutes accessibles depuis le bot lui-même, sur le salon du quiz.
;;;
;;; Show commands en question :
;;;
;;; Ces commandes sont à entrer par le maestro ou par le bot sur le salon où a lieu le quiz :
;;; !win <pseudo> fait gagner un joueur pendant le laps de temps attribué à une question.
;;; +1 <pseudo> ajoute un point à un joueur n'importe quand. Le joueur est averti par une notice.
;;; -1 <pseudo> retire un point à un joueur n'importe quand. Le joueur n'est pas averti par une notice.

alias start {

  set %basedir scripts\ef_mono\

  .timers off
  unset %efm_*
  unset %ef_*
  set %ef_nbq $lines(%basedir $+ questions.txt)

  if (!%token_line) { set %token_line $asc(\) }

  if (!$check_file(%basedir $+ questions.txt)) {
    echo -a 4Vérifiez que la question et les réponses soient séparées par le caractère " $+ $chr(%token_line) $+ ", sur chaque ligne du fichier.
    return $false
  }

  if ($left($1, 1) == $chr(45)) {
    set %efm_params $mid($1, 2)
  }
  if (($left($1, 1) == $chr(35)) || ($2)) {
    if ($2) {
      set %efm_chan $strip($2)
    }
    else {
      set %efm_chan $strip($1)
    }
  }
  else {
    set %efm_chan $active
  }

  if ($isfile(%basedir $+ questions.txt)) {
    copy -o %basedir $+ questions.txt %basedir $+ temp.txt
    set %ef_db %basedir $+ temp.txt
  }
  else {
    echo -a 4Le fichier de questions est introuvable.
    return $false
  }

  set %efm_t_start 15
  set %efm_t_warning 40
  set %efm_t_norep 25
  set %efm_t_indice 25

  set %efm_tocount 20
  set %efm_tocount_answers $false

  efm_start
}
alias maestro {
  set %maestro $$1
  echo -a Le maestro du quiz sera $1 $+ .
}
alias settoken {
  if ($1) {
    set %token_line $asc($1)
  }
  else {
    set %token_line $asc(\)
  }
  echo -a 12Le séparateur question\réponse est " $+ $chr(%token_line) $+ "
}
alias check_file {
  set %efm_nbcheck 0
  filter -ffcb $$1 $1 *?*
  filter -fknx $1 cfa * $+ $chr(%token_line) $+ *
  if (%efm_errors == $null) {
    return $true
  }
  else {
    echo -a 4Erreurs trouvées dans le fichier questions.txt :
    var %i = 1, %line
    while (%i <= $numtok(%efm_errors, 44)) {
      %line = $gettok(%efm_errors, %i, 44)
      echo -a Ligne n° $+ $gettok(%line, 1, 32) : $gettok(%line, 2, 32)
      inc %i
    }
    return $false
  }
}
alias cfa {
  set %efm_errors $addtok(%efm_errors, $1, 44)
}
alias efm_indice {
  var %reponse = $ef_noart_simple($strip($ucfirst($gettok(%ef_reponses, 1, 18))))
  if ((%reponse isnum) && ($len(%reponse) == 4)) {
    .timer_efm_indice 1 %efm_t_indice /msg %efm_chan Une petite aide : _ _ $mid(%reponse, 3, 1) _
  }
  else {
    var %nb_lettres = $ceil($calc(25 * $len(%reponse) / 100))
    if ($len(%reponse) > 1) .timer_efm_indice 1 %efm_t_indice /msg %efm_chan Une petite aide : $left(%reponse, %nb_lettres) $+ ...
  }
}
alias stop {
  .timer_efm_* off
  unset %ef_reponses
  msg %efm_chan Le quiz a été arrêté, pas de panique je reviens.
}
alias restart {
  msg %efm_chan Le jeu va reprendre dans %efm_t_start secondes ...
  .timer_efm_jeu 1 %efm_t_start /efm_jeu
}
alias efm_start {
  msg %efm_chan Le quiz commence dans %efm_t_start secondes ...
  .timer_efm_jeu 1 %efm_t_start efm_jeu
}
alias efm_jeu {
  efm_select

  msg %efm_chan  $+ %ef_question

  if (%maestro) {
    notice %maestro Réponse : $gettok(%ef_reponses, 1, 18)
  }
  echo -a Réponse : $gettok(%ef_reponses, 1, 18)

  set %efm_tocount_answers $false

  efm_indice
  .timer_efm_warning 1 %efm_t_warning /efm_warning
}
alias efm_select {
  if ($file(%ef_db).size == 0) {
    efm_fin
  }
  else {
    var %line = $read(%ef_db);
    write -dl $+ $readn %ef_db

    var %i = 1
    while (%i <= $numtok(%line, %token_line)) {
      if (%i == 1) {
        var %question = $ucfirst($strip($gettok(%line, %i, %token_line)))
        if ($right(%question, 1) != ?) {
          %question = %question ?
        }
        elseif ($right(%question, 2) != $chr(32)) {
          %question = $mid(%question, 1, $calc($len(%question) - 1)) ?
        }
        set %ef_question ( $+ $lines(%ef_db) $+ / $+ %ef_nbq $+ ) %question
      }
      else set %ef_reponses $addtok(%ef_reponses, $ucfirst($strip($gettok(%line, %i, %token_line))), 18)
      inc %i
    }
  }
}
alias ucfirst {
  return $upper($left($$1, 1)) $+ $mid($1, 2, $calc($len($1)))
}
alias rmscores {
  hdel -sw ef_scores *
  hsave -o ef_scores %basedir $+ scores
  unset %nicks
  echo -a Les scores ont été remis à zéro.
}
alias efm_warning {
  if (%efm_tocount_answers > %efm_tocount) {
    msg %efm_chan [Plus que $calc(%efm_t_warning - %efm_t_norep) secondes] %ef_question
  }
  else msg %efm_chan Il vous reste $calc(%efm_t_warning - %efm_t_norep) secondes pour donner la bonne réponse !
  .timer_efm_norep 1 $calc(%efm_t_warning - %efm_t_norep) /efm_norep
}
alias efm_norep {
  var %r = $gettok(%ef_reponses, 1, 18)
  unset %ef_reponses
  .timer_efm_* off
  msg %efm_chan Le temps imparti est écoulé, la bonne réponse était :  $+ %r $+ .
  .timer_efm_jeu 1 %efm_t_start /efm_jeu
}
alias efm_check {
  var %i = 1, %r

  while (%i <= $numtok(%ef_reponses, 18)) {
    %r = $gettok(%ef_reponses, %i, 18)

    if ($ef_del_end_punct($ef_nopunct($ef_noart_simple($$2-))) == $ef_del_end_punct($ef_nopunct($ef_noart_simple(%r)))) {
      mode %efm_chan +v $$1
      unset %ef_reponses
      .timer_efm_* off

      msg %efm_chan Bravo à $1 qui a trouvé la bonne réponse ( $+ %r $+ ) ! Score : $efm_score($1)
      set %nicks $addtok(%nicks, $1, 32)
      .timer_efm_jeu 1 %efm_t_start /efm_jeu
      break
    }

    inc %i
  }
}

alias efm_score {
  if (!$2) {
    hinc -m ef_scores $$1 1
  }
  else {
    hdec -m ef_scores $$1 1
  }
  hsave -o ef_scores %basedir $+ scores
  return $hget(ef_scores, $1)

}

alias efm_fin {
  .timer_efm_* off
  unset %ef_reponses
  msg %efm_chan J'ai fait le tour des questions, le jeu est terminé, bravo à vous tous :)
  .timer 1 10 /msg %efm_chan  $+ Le grand vainqueur de ce quiz est $efm_define_winner() $+ , un grand bravo à lui ainsi qu'à tous les participants ! À bientôt pour un autre quiz !
  .timer 1 20 /scores
  if (u isin %efm_params) {
    rmscores
    .timer 1 30 /msg %efm_chan Les scores ont été remis à 0.
    .timer 1 40 /msg %efm_chan Le quiz va redémarrer dans 25 secondes !
    .timer 1 50 /start
  }
  .halt
}
alias ef_nopunct {
  return $replace($lower($$1-),-,$chr(32),à,a,ä,a,â,a,ã,a,ç,c,é,e,è,e,ë,e,ê,e,ì,i,ï,i,î,i,ô,o,ö,o,ò,o,õ,o,û,u,ü,u,ù,u,ÿ,y)
}
alias ef_noart_simple {

  ;;;virer le, la, en, de, un, du, au, l', d', une, les, des, aux, d'un

  tokenize 32 $$1-

  ;;;articles de deux lettres
  if ($1 == le) return $$2-
  elseif ($1 == la) return $$2-
  elseif ($1 == en) return $$2-
  elseif ($1 == de) return $$2-
  elseif ($1 == un) return $$2-
  elseif ($1 == du) return $$2-
  elseif ($1 == au) return $$2-

  ;;;articles contractés + articles
  elseif ($1 == d'un) return $$2-
  elseif ($1 == d'en) return $$2-

  ;;;articles contractés
  elseif ($mid($1, 1, 2) == l') return $mid($1, 3, $len($1-))
  elseif ($mid($1, 1, 2) == d') return $mid($1, 3, $len($1-))

  ;;;articles de trois lettres
  elseif ($1 == une) return $$2-
  elseif ($1 == les) return $$2-
  elseif ($1 == des) return $$2-
  elseif ($1 == aux) return $$2-

  return $$1-
}
alias ef_del_end_punct {
  var %last_char = $right($strip($$1), 1)

  if (%last_char isin .!?) {
    return $strip($mid($1, 1, $calc($len($1)-1)))
  }
  else return $strip($1)
}
alias scores {

  var %i = 1, %j = 0, %n, %s, %efm_scores, %buffer, %len_line = 0, %lines = 0, %ellipsis = $null

  while (%i <= $numtok(%nicks, 32)) {
    %n = $gettok(%nicks, %i, 32)
    %efm_scores = $addtok(%efm_scores, $hget(ef_scores, %n) $+ : $+ %n, 32)
    inc %i
  }

  %efm_scores = $sorttok(%efm_scores, 32, nr)

  %i = 1
  while (%i <= $numtok(%efm_scores, 32)) {
    %s = $gettok(%efm_scores, %i, 32)
    %buffer = n° $+ %i $gettok(%s, 2, 58) : $gettok(%s, 1, 58)
    %len_line = $len(%r [ $+ [ %lines ] ])
    if (%len_line > 300) {
      inc %lines
      %len_line = 0
      if (%r [ $+ [ %lines ] ]) %buffer = , %buffer
      var %r $+ %lines %r [ $+ [ %lines ] ] $+ %buffer
    }
    else {
      if (%r [ $+ [ %lines ] ]) %buffer = , %buffer
      var %r $+ %lines %r [ $+ [ %lines ] ] $+ %buffer
    }
    inc %i
  }
  if (!%r0) echo -a Tous les scores sont à zéro.
  else {
    if ($1) echo -a Top scores : $+ %r
    else {
      while (%j <= %lines) {
        if (%j != %lines) %ellipsis = ...
        else %ellipsis = $null
        if (%j == 0) {
          msg $active Top scores : %r [ $+ [ %j ] ] %ellipsis
        }
        else {
          .timer 1 $calc(5 * %j) /msg $active  $+ %r [ $+ [ %j ] ] %ellipsis
        }
        inc %j
      }
    }
  }
}
alias efm_define_winner {
  var %i = 1, %n, %r
  while (%i <= $numtok(%nicks, 32)) {
    %n = $gettok(%nicks, %i, 32)
    %efm_scores = $addtok(%efm_scores, $hget(ef_scores, %n) $+ : $+ %n, 32)
    inc %i
  }
  %r = $sorttok(%efm_scores, 32, nr)
  return $strip($gettok($gettok(%r, 2, 58), 1, 32))
}
on ^*:TEXT:*:#:{
  if ((%basedir == scripts\ef_mono\) && ($chan == %efm_chan)) {

    if (!%efm_tocount_answers) set %efm_tocount_answers 1
    else inc %efm_tocount_answers

    efm_check $nick $strip($1-)
  }
  if ($chan == %efm_chan) {
    if (($strip($1) == !win) && ($nick == %maestro) && (%ef_reponses)) {
      mode %efm_chan +v $$1
      var %reponse = $gettok(%ef_reponses, 1, 18)
      unset %ef_reponses
      .timer_efm_* off

      msg %efm_chan Bravo à $2 qui a trouvé la bonne réponse qui était " $+ %reponse $+ " ! Score : $efm_score($2)
      set %nicks $addtok(%nicks, $2, 32)
      .timer_efm_jeu 1 %efm_t_start /efm_jeu
    }
    if (($strip($1) == +1) && ($nick == %maestro)) {
      efm_score $$2
      set %nicks $addtok(%nicks, $2, 32)
      notice $2 Tu as un point supplémentaire.
    }
    if (($strip($1) == -1) && ($nick == %maestro)) {
      efm_score $$2 $true
    }
  }
}
on *:INPUT:#:{
  if ($chan == %efm_chan) {
    if (($strip($1) == !win) && (%ef_reponses)) {
      mode %efm_chan +v $$1
      var %reponse = $gettok(%ef_reponses, 1, 18)
      unset %ef_reponses
      .timer_efm_* off

      .timer -m 1 1 /msg %efm_chan Bravo à $2 qui a trouvé la bonne réponse qui était " $+ %reponse $+ " ! Score : $efm_score($2)
      set %nicks $addtok(%nicks, $2, 32)
      .timer_efm_jeu 1 %efm_t_start /efm_jeu
    }
    if ($strip($1) == +1) {
      efm_score $$2
      set %nicks $addtok(%nicks, $2, 32)
      .timer -m 1 1 /notice $2 Tu as un point supplémentaire.
    }
    if ($strip($1) == -1) {
      efm_score $$2 $true
    }
  }
}
on *:NICK:{
  if (%efm_chan) {
    var %s = $hget(ef_scores, $nick)
    hdel ef_scores $nick
    hadd ef_scores $newnick %s
    set %nicks $reptok(%nicks, $nick, $newnick, 1, 32)
  }
}
on *:START:{
  hmake ef_scores 1000
  if ($exists(%basedir $+ scores)) hload ef_scores %basedir $+ scores
  set %maestro $null
}
